﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDataSource;

namespace UltraGridHierarchicalWithObjects
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            List<Document> DocumentList = new List<Document>();
            for (int i = 0; i < 10; i++)
            {
                DocumentList.Add(this.CreateSampleData(i));
            }

            ultraGrid1.DataSource = DocumentList.ToList();
            ultraGrid1.InitializeLogicalPrintPage += new Infragistics.Win.UltraWinGrid.InitializeLogicalPrintPageEventHandler(ultraGrid1_InitializeLogicalPrintPage);
        }

        void ultraGrid1_InitializeLogicalPrintPage(object sender, Infragistics.Win.UltraWinGrid.CancelableLogicalPrintPageEventArgs e)
        {
            
        }

        private  Document CreateSampleData(int i)
        {
            Document doc = new Document();
            doc.DocumentID = i;
            doc.FechaDocumento = "Document " + i.ToString() ;
            doc.NumeroDocumentoAsignadoPorEmisor = "AAAAAAA "+ i.ToString();
            doc.SubTipoDocumento = "BBBBB "+ i.ToString();
            doc.TipoDocumento = "CCCCCCC "+ i.ToString();

            for (int k = 0; k < 5; k++)
            {
                DocumentInfo docInfo = new DocumentInfo();
                docInfo.DocumentID = i;
                docInfo.Number = "Number " + i.ToString();
                docInfo.PuntoOperacional = "Test " + i.ToString();
                docInfo.Type = "My type" + i.ToString();
                doc.DocumentInfoList.Add(docInfo);
            }
            return doc;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[1].Header.Appearance.BackColor = Color.Yellow;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = Color.Yellow;

            e.Layout.Bands[1].Columns[2].Header.Appearance.BackColor = Color.Cyan;// Navy;
            e.Layout.Bands[1].Columns[2].CellAppearance.BackColor = Color.Red;
            e.Layout.Bands[1].Columns[0].CellAppearance.BackColor = Color.Yellow;
        }

     

        
    }

    public class Document
    {

        #region Properties
        private int documentID;

        public int DocumentID
        {
            get { return documentID; }
            set { documentID = value; }
        }

        private string tipoDocumento;

        public string TipoDocumento
        {
            get { return tipoDocumento; }
            set { tipoDocumento = value; }
        }

        private string subTipoDocumento;

        public string SubTipoDocumento
        {
            get { return subTipoDocumento; }
            set { subTipoDocumento = value; }
        }

        private string numeroDocumentoAsignadoPorEmisor;

        public string NumeroDocumentoAsignadoPorEmisor
        {
            get { return numeroDocumentoAsignadoPorEmisor; }
            set { numeroDocumentoAsignadoPorEmisor = value; }
        }

        private string fechaDocumento;

        public string FechaDocumento
        {
            get { return fechaDocumento; }
            set { fechaDocumento = value; }
        }

        private List<DocumentInfo> documentInfoList;

        public List<DocumentInfo> DocumentInfoList
        {
            get { return documentInfoList; }
            set { documentInfoList = value; }
        }

        #endregion Properties

        #region Constructors
        public Document()
        {
            this.documentInfoList = new List<DocumentInfo>();
        }

        #endregion Constructors
    }


    public  class DocumentInfo
    {
        #region Properties
        private int documentID;

        public int DocumentID
        {
            get { return documentID; }
            set { documentID = value; }
        }

        private string type;

        public string Type
        {
            get { return type; }
            set { type = value; }
        }

        private string puntoOperacional;

        public string PuntoOperacional
        {
            get { return puntoOperacional; }
            set { puntoOperacional = value; }
        }

        private string number;

        public string Number
        {
            get { return number; }
            set { number = value; }
        }
        
        #endregion Properties

        #region Constructors

        public DocumentInfo()
        { }
        #endregion
    }

}
